local toc, data = ...
local id = toc.identifier

local player = ""
local inCombat = false

local startMsg = "Gadgets: IDHelper enabled, type /idhStop to disable"
local stopMsg = "Gadgets: IDHelper disabled, type /idhStart to enable"

local rgbRed = { r = .75, g = .25, b = .25, a = .9,
                fr = .9 ,fg = .9 ,fb = .9 ,fa = 1 }
local rgbGreen = { r = .25, g = .75, b = .25, a = .9,
                  fr = .1 ,fg = .1 ,fb = .1 ,fa = 1 }
local rgbBlue = { r = .25, g = .25, b = .75, a = .9,
                 fr = .9 ,fg = .9 ,fb = .9 ,fa = 1 }
local rgbPurple = { r =   0.676, g =   0.281, b =    0.98, a = .9,
                 fr = .9 ,fg = .9 ,fb = .9 ,fa = 1 }
local rgbYellow = { r = 1  , g = .96, b = .41, a = .9,
                   fr = .1 ,fg = .1 ,fb = .1 ,fa = 1 }

local RED = "RED"
local GREEN = "GREEN"
local BLUE = "BLUE"
local YELLOW = "YELLOW"
local PURPLE = "PURPLE"

local LEFT = "LEFT"
local RIGHT = "RIGHT"
local FORWARD = "FORWARD"
local BACK = "BACK"
local AWAY = "AWAY"

local IDH = {
    Drak = { loc = "Gates of Carcera" },
    Gorlach = { loc = "Gates of Carcera" },
    Ituziel = { loc = "Circle of Flame" },
    Conclave = { loc = "The Ossuary" },
    Maklamos = { loc = "Crystalline Grotto" },
    Rusila = { loc = "The Dread Fortune" },
    Laethys = { loc = "The Golden Hoard" },
    Eggs = { loc = "Core of Carcera" },
    Maelforge = { loc = "Spires of Sacrifice" },
}
IDH.Drak.track = false

IDH.Gorlach.track = true
IDH.Gorlach.hotFoot = { name = "Hot Foot", dir = AWAY, color = PURPLE}
--IDH.Gorlach.loc = "Thedeor's Circle"
--IDH.Gorlach.hotFoot = { name = "Destroyer's Bearing", dir = AWAY, color = PURPLE}

IDH.Ituziel.track = false

IDH.Conclave.track = true
IDH.Conclave.feedback = { name = "Infernal Feedback", dir = "STOP EVERYTHING", color = RED}

IDH.Maklamos.track = true
IDH.Maklamos.red = { name = "Scarlet Crystal Essence", dir = FORWARD, color = RED}
IDH.Maklamos.green = { name = "Emerald Crystal Essence", dir = LEFT, color = GREEN}
IDH.Maklamos.blue = { name = "Azure Crystal Essence", dir = RIGHT, color = BLUE}

IDH.Rusila.track = false

IDH.Laethys.track = false

IDH.Eggs.track = true
IDH.Eggs.hellfire = { name = "Hellfire", dir = AWAY, color = YELLOW}

IDH.Maelforge.track = true
IDH.Maelforge.earthen = { name = "Earthen Fissure", dir = LEFT, color = YELLOW}
IDH.Maelforge.fiery = { name = "Fiery Fissure", dir = RIGHT, color = RED}
IDH.Maelforge.hellfireGreen = { name = "B0E7E2D5A0A251BA2", dir = LEFT, color = GREEN}
IDH.Maelforge.hellfireYellow = { name = "B58F6969FA32C3353", dir = RIGHT, color = YELLOW}

local messageActive = false
local messageBuffID = ""

local wykkydIDHReady      = 0

local idhWindows = {}

local function moveTo(wrn, dir, prn, bg)
    if bg == RED then
        c = rgbRed
    elseif bg == GREEN then
        c = rgbGreen
    elseif bg == BLUE then
        c = rgbBlue
    elseif bg == YELLOW then
        c = rgbYellow
    elseif bg == PURPLE then
        c = rgbPurple
    end
    if dir == LEFT then
        a = "<< "..wrn
    elseif dir == RIGHT then
        a = wrn.." >>"
    elseif dir == FORWARD then
        a = "^ "..wrn.." ^"
    elseif dir == BACK then
        a = "v "..wrn.." v"
    elseif dir == AWAY then
        a = "<< "..wrn.." >>"
    else a = dir; prn = dir;
    end
    for _, win in pairs(idhWindows) do
        win:SetFontColor( c.fr, c.fg, c.fb, c.fa )
        win:SetBackgroundColor( c.r, c.g, c.b, c.a )
        win:SetText( a )
    end
    messageActive = true
    print( prn )
end

local function clearMessage()
    messageActive = false
    messageBuffID = ""
    for _, win in pairs(idhWindows) do
        win:SetBackgroundColor( 0.0, 0.0, 0.0, 0.0)
        win:SetText("")
    end
end

local function checkbuffSpecific(unit, buff, compare, dir, color)
    if buff.type == compare or buff.name == compare then
        if messageActive == false then
            moveTo( "MOVE "..dir, dir, "Move "..dir.." ( "..buff.name.." )", color )
        end 
        return true
    end
    return false
end

local function tryCheckBuff(unit, buff, compare, dir, color)
    local details = Inspect.Buff.Detail(unit, buff)
    if details then
        return checkbuffSpecific(unit, details, compare, dir, color)
    else
        return false
    end
end

local curUnit = nil

local function checkPrecise(buff)
    if inCombat then
        local hasBuff = false 
        local unit = "player"
        local p = curUnit
        if p.locationName == IDH.Drak.loc then 
            if not IDH.Drak.track then return end
        elseif p.locationName == IDH.Gorlach.loc then
            if not IDH.Gorlach.track then return end
            if not hasBuff then hasBuff = tryCheckBuff(unit, buff, IDH.Gorlach.hotFoot.name, IDH.Gorlach.hotFoot.dir, IDH.Gorlach.hotFoot.color); if hasBuff then return end; end
        elseif p.locationName == IDH.Ituziel.loc then
            if not IDH.Ituziel.track then return end
        elseif p.locationName == IDH.Conclave.loc then
            if not IDH.Conclave.track then return end
            if not hasBuff then hasBuff = tryCheckBuff(unit, buff, IDH.Conclave.feedback.name, IDH.Conclave.feedback.dir, IDH.Conclave.feedback.color); if hasBuff then return end; end
        elseif p.locationName == IDH.Maklamos.loc then
            if not IDH.Maklamos.track then return end
            if not hasBuff then hasBuff = tryCheckBuff(unit, buff, IDH.Maklamos.red.name, IDH.Maklamos.red.dir, IDH.Maklamos.red.color); if hasBuff then return end; end
            if not hasBuff then hasBuff = tryCheckBuff(unit, buff, IDH.Maklamos.green.name, IDH.Maklamos.green.dir, IDH.Maklamos.green.color); if hasBuff then return end; end
            if not hasBuff then hasBuff = tryCheckBuff(unit, buff, IDH.Maklamos.blue.name, IDH.Maklamos.blue.dir, IDH.Maklamos.blue.color); if hasBuff then return end; end
        elseif p.locationName == IDH.Rusila.loc then
            if not IDH.Rusila.track then return end
        elseif p.locationName == IDH.Laethys.loc then
            if not IDH.Laethys.track then return end
        elseif p.locationName == IDH.Eggs.loc then
            if not IDH.Eggs.track then return end
            if not hasBuff then hasBuff = tryCheckBuff(unit, buff, IDH.Eggs.hellfire.name, IDH.Eggs.hellfire.dir, IDH.Eggs.hellfire.color); if hasBuff then return end; end
        elseif p.locationName == IDH.Maelforge.loc then
            if not IDH.Maelforge.track then return end
            if not hasBuff then hasBuff = tryCheckBuff(unit, buff, IDH.Maelforge.earthen.name, IDH.Maelforge.earthen.dir, IDH.Maelforge.earthen.color); if hasBuff then return end; end
            if not hasBuff then hasBuff = tryCheckBuff(unit, buff, IDH.Maelforge.fiery.name, IDH.Maelforge.fiery.dir, IDH.Maelforge.fiery.color); if hasBuff then return end; end
            if not hasBuff then hasBuff = tryCheckBuff(unit, buff, IDH.Maelforge.hellfireGreen.name, IDH.Maelforge.hellfireGreen.dir, IDH.Maelforge.hellfireGreen.color); if hasBuff then return end; end
            if not hasBuff then hasBuff = tryCheckBuff(unit, buff, IDH.Maelforge.hellfireYellow.name, IDH.Maelforge.hellfireYellow.dir, IDH.Maelforge.hellfireYellow.color); if hasBuff then return end; end
        else return end
        if hasBuff == false then clearMessage() end
    end
end

local function idhCleanup(details)
    for u, b in pairs(details) do
        if u == player then
            if b then 
                inCombat = true
                curUnit = Inspect.Unit.Detail("player")
            else
                inCombat = false
                clearMessage()
            end
        end
    end
end
local function enterCombat() 
	inCombat = true
	curUnit = Inspect.Unit.Detail("player")
end
local function leaveCombat() 
	inCombat = false
	clearMessage()
end
local function idhUpdate(unit, updates)
    if wykkydIDHReady == 0 then return end
    if messageActive then return end
    messageBuffID = ""
    if unit == player then 
        for buff, bool in pairs(updates) do 
            checkPrecise(buff) 
            if messageActive then messageBuffID = buff end
        end
    end
end
local function idhSoftUpdate(unit, updates)
    if wykkydIDHReady == 0 then return end
    if not messageActive then return end
    if unit == player then 
        for buff, bool in pairs(updates) do 
            if messageBuffID == buff then
                clearMessage()
            end
        end
    end
end

local function cycle(n)
    wykkydIDHReady = n
    clearMessage()
    messageActive = false
    messageBuffID = ""
    for _, win in pairs(idhWindows) do
        win:SetBackgroundColor(0.0,0.0,0.0,0.0)
        win:SetText("")
    end
end
local function idhStart() cycle(1); print(startMsg); end
local function idhStop() cycle(0); print(stopMsg); end

local function Create(configuration)
    local u = Inspect.Unit.Lookup("player")
    player = u
    
    IDH.Gorlach.hotFoot.dir = configuration.scarletcrystalDir
    
    IDH.Maklamos.red.dir    = configuration.scarletcrystalDir or FORWARD
    IDH.Maklamos.green.dir  = configuration.emeraldcrystalDir or LEFT
    IDH.Maklamos.blue.dir   = configuration.azurecrystalDir or RIGHT
    
    IDH.Eggs.hellfire.dir   = configuration.eggHellfireDir or AWAY
    
    IDH.Maelforge.earthen.dir           = configuration.earthenfissureDir or LEFT
    IDH.Maelforge.fiery.dir             = configuration.fieryfissureDir or RIGHT
    IDH.Maelforge.hellfireGreen.dir     = configuration.hellfiregreenDir or LEFT
    IDH.Maelforge.hellfireYellow.dir    = configuration.hellfireyellowDir or RIGHT
    
	local wykkydIDHPanel = UI.CreateFrame("Frame", WT.UniqueName("Wykkyd.IDHelper"), WT.Context)
	wykkydIDHPanel:SetWidth(340)
	wykkydIDHPanel:SetHeight(50)
	wykkydIDHPanel:SetBackgroundColor(0,0,0,0.0)
    
	local idhFrame = UI.CreateFrame("Text", WT.UniqueName("Wykkyd.IDHelper"), wykkydIDHPanel)
	idhFrame:SetText("")
	idhFrame:SetFontSize(40)
	idhFrame.currText = ""
    
	idhFrame:SetPoint("TOPCENTER", wykkydIDHPanel, "TOPCENTER", 0, 0)
        
	table.insert(idhWindows, idhFrame)
    table.insert(Event.Buff.Add,{idhUpdate, "Gadgets_IDHelper", "wykkydUpdate" })
    table.insert(Event.Buff.Remove,{idhSoftUpdate, "Gadgets_IDHelper", "wykkydSoftUpdate" })
	table.insert(Event.System.Secure.Enter, {enterCombat, "Gadgets_IDHelper", "idhCleanup"} )
	table.insert(Event.System.Secure.Leave, {leaveCombat, "Gadgets_IDHelper", "idhCleanup"} )
    --table.insert(Event.Unit.Detail.Combat,  {idhCleanup,  "Gadgets_IDHelper", "idhCleanup"} )
    table.insert(Command.Slash.Register("idhReset"),  {idhCleanup,  "Gadgets_IDHelper", "idhReset"} )
    table.insert(Command.Slash.Register("idhStop"),  {idhStop,  "Gadgets_IDHelper", "idhStop"} )
    table.insert(Command.Slash.Register("idhStart"), {idhStart, "Gadgets_IDHelper", "idhStart"})
    idhStart()
	return wykkydIDHPanel, { resizable={340, 50, 340, 50} }
end

local dialog = false

local function ConfigDialog(container)
	dialog = WT.Dialog(container)
		:Label("Maklamos (HM) Crystal Alerts:")
        :Combobox("scarletcrystalDir", "- Scarlet Crystal", IDH.Maklamos.red.dir, {
				{text="We move to the Left", value=LEFT},
				{text="We move to the Right", value=RIGHT},
				{text="We move Forward", value=FORWARD},
				{text="We move Backward", value=BACK},
			}, false) 
        :Combobox("emeraldcrystalDir", "- Emerald Crystal", IDH.Maklamos.green.dir, {
				{text="We move to the Left", value=LEFT},
				{text="We move to the Right", value=RIGHT},
				{text="We move Forward", value=FORWARD},
				{text="We move Backward", value=BACK},
			}, false) 
        :Combobox("azurecrystalDir", "- Azure Crystal", IDH.Maklamos.blue.dir, {
				{text="We move to the Left", value=LEFT},
				{text="We move to the Right", value=RIGHT},
				{text="We move Forward", value=FORWARD},
				{text="We move Backward", value=BACK},
			}, false) 
		:Label("\nDragon Eggs Alerts:")
        :Combobox("eggHellfireDir", "- Hellfire (phase 3 bubble)", IDH.Eggs.hellfire.dir, {
				{text="We move to the Left", value=LEFT},
				{text="We move to the Right", value=RIGHT},
				{text="We move Forward", value=FORWARD},
				{text="We move Backward", value=BACK},
				{text="We move Away!", value=AWAY},
			}, false) 
		:Label("\nMaelforge Alerts:")
        :Combobox("earthenfissureDir", "- Earthen Fissure (phase 1)", IDH.Maelforge.earthen.dir, {
				{text="We move to the Left", value=LEFT},
				{text="We move to the Right", value=RIGHT},
			}, false) 
        :Combobox("fieryfissureDir", "- Fiery Fissure (phase 1)", IDH.Maelforge.fiery.dir, {
				{text="We move to the Left", value=LEFT},
				{text="We move to the Right", value=RIGHT},
			}, false) 
        :Combobox("hellfiregreenDir", "- Hellfire (GREEN)", IDH.Maelforge.hellfireGreen.dir, {
				{text="We move to the Left", value=LEFT},
				{text="We move to the Right", value=RIGHT},
			}, false) 
        :Combobox("hellfireyellowDir", "- Hellfire (YELLOW)", IDH.Maelforge.hellfireYellow.dir, {
				{text="We move to the Left", value=LEFT},
				{text="We move to the Right", value=RIGHT},
			}, false) 
end

local function GetConfiguration() return dialog:GetValues() end

local function SetConfiguration(config) dialog:SetValues(config) end

WT.Gadget.RegisterFactory("wykkydIDHelper", {
		name="ID Helper Panel",
		description="Small window that tells you to move",
		author=toc.toc.Author,
		version=toc.toc.Version,
		["Create"] = Create,
		["ConfigDialog"] = ConfigDialog,
		["GetConfiguration"] = GetConfiguration, 
		["SetConfiguration"] = SetConfiguration, 
	})
 